package com.base.datarecovery.fragment

import android.animation.AnimatorSet
import android.animation.ObjectAnimator
import android.annotation.SuppressLint
import android.app.usage.StorageStatsManager
import android.content.ClipData
import android.content.ClipboardManager
import android.content.Context
import android.content.Intent
import android.os.Build
import android.os.Environment
import android.os.StatFs
import android.os.storage.StorageManager
import android.view.View
import android.view.animation.AccelerateDecelerateInterpolator
import android.widget.Toast
import androidx.appcompat.app.AppCompatActivity
import com.base.datarecovery.R
import com.base.datarecovery.activity.SettingActivity
import com.base.datarecovery.activity.battery.BatteryInfoAnimationActivity
import com.base.datarecovery.activity.junkclean.ScanJunk2Activity
import com.base.datarecovery.activity.junkclean.ScanJunkActivity
import com.base.datarecovery.activity.largefile.LargeFileAnimationActivity
import com.base.datarecovery.activity.newfunction.WeatherInterface
import com.base.datarecovery.activity.newfunction.WeatherUtils
import com.base.datarecovery.activity.newfunction.XingzuoLoadingActivity
import com.base.datarecovery.activity.repeat.RepeatAnimationActivity
import com.base.datarecovery.activity.screenshot.ScreenShotAnimationActivity
import com.base.datarecovery.activity.videomanager.VideoCleanAnimationActivity
import com.base.datarecovery.ads.AdmobMaxHelper
import com.base.datarecovery.databinding.FragmentHomeBinding
import com.base.datarecovery.help.BaseFragment
import com.base.datarecovery.help.KotlinExt.toFormatSize
import com.base.datarecovery.utils.AppPreferences
import java.io.File
import kotlin.random.Random

class HomeFragment : BaseFragment<FragmentHomeBinding>() {

    override val binding: FragmentHomeBinding by lazy {
        FragmentHomeBinding.inflate(layoutInflater)
    }
    private lateinit var animatorSet: AnimatorSet


    override fun setView() {
        animatorSet = createHeartbeatAnimation(binding.flScan)
        showStorage()
    }

    var i = 0
    private var lastClickTime = 0L
    override fun setListener() {
        binding.flScan.setOnClickListener {
            val jumpJunkFirstAd =
                AppPreferences.getInstance().getString("isjunkPlayAd", "0").toInt()

            if (jumpJunkFirstAd == 1) {
                startActivity(Intent(requireContext(), ScanJunk2Activity::class.java))
            } else {
                startActivity(Intent(requireContext(), ScanJunkActivity::class.java))
            }

//            sendNotification(requireContext(), ConstObject.ID_JUNK_CLEAN_PUSH)
        }
        binding.tvClean.setOnClickListener {
            val jumpJunkFirstAd =
                AppPreferences.getInstance().getString("isjunkPlayAd", "0").toInt()

            if (jumpJunkFirstAd == 1) {
                startActivity(Intent(requireContext(), ScanJunk2Activity::class.java))
            } else {
                startActivity(Intent(requireContext(), ScanJunkActivity::class.java))
            }
        }


        binding.cardCleanJunk.setOnClickListener {
            val jumpJunkFirstAd =
                AppPreferences.getInstance().getString("isjunkPlayAd", "0").toInt()

            if (jumpJunkFirstAd == 1) {
                startActivity(Intent(requireContext(), ScanJunk2Activity::class.java))
            } else {
                startActivity(Intent(requireContext(), ScanJunkActivity::class.java))
            }
        }
//        binding.cardWhatsApp.setOnClickListener {
//            startActivity(Intent(requireContext(), WhatsAppCleanerAnimationActivity::class.java))
//        }
        binding.cardLargeFile.setOnClickListener {
            startActivity(Intent(requireContext(), LargeFileAnimationActivity::class.java))
        }

        binding.cardVideo.setOnClickListener {
            startActivity(Intent(requireContext(), VideoCleanAnimationActivity::class.java))
        }
//        binding.cardAppProcess.setOnClickListener {
//            startActivity(Intent(requireContext(), AppProcessAnimationActivity::class.java))
//        }
        binding.cardBatteryInfo.setOnClickListener {
            startActivity(Intent(requireContext(), BatteryInfoAnimationActivity::class.java))
        }
        binding.cardScreenshot.setOnClickListener {
            startActivity(Intent(requireContext(), ScreenShotAnimationActivity::class.java))

        }
        binding.cardDuplicatephoto.setOnClickListener {
            startActivity(Intent(requireContext(), RepeatAnimationActivity::class.java))

        }
        binding.flSetting.setOnClickListener {
            startActivity(Intent(requireContext(), SettingActivity::class.java))
        }
        binding.tvTitle.setOnClickListener {
            if (System.currentTimeMillis() - lastClickTime > 5 * 1000 && i != 0) {
                lastClickTime = 0
                i = 0
            }
            if (i == 20) {
                copyUuidGid()
                i = 0
            }
            i++
            lastClickTime = System.currentTimeMillis()
        }
        binding.idXz.setOnClickListener {
            startActivity(Intent(requireActivity(), XingzuoLoadingActivity::class.java))
        }
        binding.llWeather.setOnClickListener {
            startActivity(Intent(requireActivity(), WeatherInterface::class.java))
        }
    }

    private fun copyUuidGid() {
        val uuid = AppPreferences.getInstance().getString("uuid", "")
        val gid = AppPreferences.getInstance().getString("gid", "")
        // 获取系统服务ClipboardManager
        val clipboard: ClipboardManager =
            requireContext().getSystemService(AppCompatActivity.CLIPBOARD_SERVICE) as ClipboardManager
        // 创建一个ClipData对象，其中包含要复制的文本
        val clip = ClipData.newPlainText("uuid", "uuid=$uuid gid=$gid")
        // 将ClipData对象设置到剪贴板中
        clipboard.setPrimaryClip(clip)
        Toast.makeText(requireContext(), "copy", Toast.LENGTH_SHORT).show()
    }

    @SuppressLint("Recycle")
    fun createHeartbeatAnimation(view: View): AnimatorSet {
        // 创建放大动画
        val scaleUpAnimator = ObjectAnimator.ofFloat(view, "scaleX", 1f, 1.1f)
        scaleUpAnimator.setDuration(500)
        scaleUpAnimator.interpolator = AccelerateDecelerateInterpolator()
        scaleUpAnimator.repeatCount = ObjectAnimator.INFINITE
        scaleUpAnimator.repeatMode = ObjectAnimator.REVERSE

        // 创建缩小动画
        val scaleDownAnimator = ObjectAnimator.ofFloat(view, "scaleY", 1.1f, 1f)
        scaleDownAnimator.setDuration(500)
        scaleDownAnimator.interpolator = AccelerateDecelerateInterpolator()
        scaleDownAnimator.setStartDelay(500) // 延迟开始，以便与放大动画同步结束
        scaleDownAnimator.repeatCount = ObjectAnimator.INFINITE
        scaleDownAnimator.repeatMode = ObjectAnimator.REVERSE

        // 组合放大和缩小动画
        val animatorSet = AnimatorSet()
        animatorSet.play(scaleUpAnimator).with(scaleDownAnimator)

        // 启动动画
        animatorSet.start()
        return animatorSet
    }

    override fun onPause() {
        super.onPause()
        animatorSet.pause()
    }


    override fun onResume() {
        super.onResume()
        AdmobMaxHelper.admobMaxShowNativeAd(requireActivity(), binding.idFlNative, 1)
        animatorSet.resume()
        val bean = WeatherUtils.getWeatherEntity()?.list?.get(0)
        bean?.let {
            var value = 22
            val min = bean.tempMin.toInt()
            val max = bean.tempMax.toInt()
            if (min == max) {
                value = max
            }
            if (min < max) {
                value = Random.nextInt(min, max)
            }
            val icon = when (WeatherUtils.getWeatherType(bean.iconDay.toInt())) {
                "Sunny day" -> R.mipmap.x_qing
                "Cloudy day" -> R.mipmap.x_yin
                "Rainy day" -> R.mipmap.x_dayu
                "Snowy day" -> R.mipmap.x_xiaxue
                "Greasy day" -> R.mipmap.x_wumaishachengbao
                "Unknown" -> R.mipmap.x_qing
                else -> R.mipmap.x_qing
            }
            binding.tvWendu.text = value.toString()
            binding.ivWeather.setImageResource(icon)
        }
    }

    @SuppressLint("SetTextI18n")
    fun showStorage() {
        binding.llStorage.visibility = View.VISIBLE

        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.R) {
            val storageStatsManager =
                requireContext().getSystemService(Context.STORAGE_STATS_SERVICE) as StorageStatsManager

            Thread {
                val totalBytes = storageStatsManager.getTotalBytes(StorageManager.UUID_DEFAULT)
                val usedBytes =
                    totalBytes - storageStatsManager.getFreeBytes(StorageManager.UUID_DEFAULT)
                binding.root.post {
                    binding.tvStorage.text =
                        "${usedBytes.toFormatSize()} / ${totalBytes.toFormatSize()}"
                }
            }.start()

        } else {
            val path1: File = Environment.getDataDirectory()
            val stat1 = StatFs(path1.path)
            val path2: File = Environment.getExternalStorageDirectory()
            val stat2 = StatFs(path2.path)
            val totalSize = (stat1.totalBytes + stat2.totalBytes).toFormatSize()
            val usedSize =
                ((stat1.totalBytes + stat2.totalBytes) - (stat1.availableBytes + stat2.availableBytes)).toFormatSize()
            binding.tvStorage.text = "$usedSize / $totalSize"
        }
    }

}